Splash release notes
====================

Splash 0.11.6 (2025-06-25)
-------------------------
Improvements:
* Make the UI more consistent and usable
* Improve statistics and logs widgets
* Improve objects short description
* Improve object name handling, hopefully reducing conflicts
* Improve readability with a new font
* Mark some attributes as generated, to allow for dropdown selection in the UI
* Add advanced attribute concept, meant to be hidden from user interface
* Moved Filter UI tabulation after Warp
* Generalize Filters widget to Textures, and add some controls
* Replace buttons and checkboxes with a menu in Cameras UI
* Improve node graph UI, including a new menu for adding objects
* Move blending, flash background and wireframe/textured buttons to Camera UI
* Improve warp mesh rendering and visibility
* Change CI to build Windows package as portable by default
* Add support for relative data directory (for semi-portable build)
* Add suport for the mold linker
* Improve code legibility for Attribute and its uses
* Improve slightly node graph rendering

Bugs fixed:
* Fix OBJ loader asking for a Z up coordinate system
* Fix UI layout for meshes, media, camera, warps and textures lists
* Fix Windows CI build to target a generic architecture
* Fix stalling issue when NDI looks for new sources
* Fix Camera UI tab layout
* Fix window fullscreen selection when monitors have the same name

Documentation:
* Add funding manifest
* Update README.md

Splash 0.11.4 (2025-05-26)
-------------------------
Improvements:
* Add matrix layouts to Window
* Improve node view by adding shortcuts and fix object add dropdown
* Changed docking shortcut to ctrl+space, as shift+tab is already widely used to move between fields
* Improve texture panel
* Add GLSL validation using glslang, and fix an issue in shaders

Bugs fixed:
* Fix stalled UI when loading a configuration, and UI is undocked
* Fix file selector for media and meshes not staying in the same folder between selections
* Fix GUI always being undocked at startup, without regard for the configuration
* Fix getting current git branch in detached HEAD state
* Fix media and mesh type change crash on Windows
* Fix shader precision directive issue on Nvidia hardware
* Fix Image_NDI crashing when setting a source while NDI library not available
* Fix Ubuntu and Debian package generation

Documentation:
* Add git version and branch in the About window

Splash 0.11.2 (2025-05-10)
-------------------------
Improvements:
* Add a specific branch to trigger Windows build by the CI
* Add running splash through xvfb in CI
* Add a new macro to help with graphics debug
* Update Snappy to version 1.2.2

Bugs fixed:
* Fix GUI window being created in all scenes instead of only the main one
* Fix unit tests for Json loading
* Fix multiple string attr display, and now hides textureList attr for Window
* Fix loading configuration as exported by the Blender addon
* Fix crash when replacing a mesh
* Fix keeping alias when replacing object, and display it as preview in UI if needed
* Fix Image_OpenCV media input
* Fix random freeze when deleting Image_NDI
* Fix ZMQ compilation with newer cmake

Documentation:
* Update metainfo

Splash 0.11.0 (2025-05-01)
-------------------------
Improvements:
* Add native support for NDI video source
* Add GUI capability to create its own window if needed
* Add Sh4lt as a submodule
* Add sh4lt selection through a combo box
* Add multiple choices selection to attributes, and a first use with
* Add automatic resize to available size for camera overview camera
* Add a preview camera to mesh UI
* Add field validation when using tab in UI
* Upgrade project to C++20
* Set Wayland to be used by default if available
* Change Window default size
* Removed (never-functional) support for multiple meshes in a single object
* Move attribute widgets to always be shown

Documentation:
* Update metainfo with URL for help, contact and donation

Bugs fixed:
* Fix attributes unit tests for attributes without setter
* Fix camera vertex picking to better handle mesh boundaries
* Fix warps not shown correctly in UI
* Fix object deletion from the GUI
* Fix dropdown not shown when more that 3 choices are available
* Fix changing media and mesh type always using the first choice
* Fix no mesh being selected by default in mesh UI
* Fix shortcut issues in Camera UI

Splash 0.10.20 (2024-11-04)
-------------------------
Bugs fixed:
* Fix multiple queues not working as expected: same content for all instances,...

Splash 0.10.18 (2024-09-02)
-------------------------
Improvements:
* Fixed package names generated by the CI

Splash 0.10.16 (2024-07-24)
-------------------------
Improvements:
* Accelerated CI through the use of Docker images

Bugs fixed:
* Fixed Image_FFmpeg by removing a deprecated function
* Fixed Window showing only the first texture connected to it, possibly multiple times

Splash 0.10.14 (2024-07-01)
-------------------------
Improvements:
* Moved mesh generation from depthmap to a thread
* Fixed depth format for ImageSh4lt and ImageShmdata to the more standard Y16
* Cleaned up the CMake project file, by removing an unecessary module

Bugs fixed:
* Fixed random crash when using the ZMQ channel backend
* Fixed image_sh4lt not initializing correctly when loading a configuration

Splash 0.10.12 (2024-06-03)
-------------------------
Improvements:
* Added Mesh_Depthmap, which creates a mesh from a depthmap and a few parameters
* Added support for 16bits images in Image, Image_Shmdata and Image_Sh4lt

Bugs fixed:
* Fixed Image_Shmdata caps parsing to accept caps with no type specified

Splash 0.10.10 (2024-04-02)
-------------------------
Bugs fixed:
* Fixed configuration trying to save the GUI camera
* Fixed GUI camera not having a name, leading sometimes to a crash
* Fixed build issue with static analysis
* Fixed navigating through calibration points with tab when no point is set

Splash 0.10.8 (2024-03-04)
-------------------------
Improvements:
* Updated imgui to 1.90.4
* Updated GLM to version 1.0.0
* Updated Snappy to 1.1.10
* Updated GLFW to version 3.4.0
* Updated libltc to 1.3.2
* Added support for Sh4lt memory sharing library
* Replaced Ubuntu 23.10 for 24.04 in CI

Documentation:
* Fixed typo in README.md

Bugs Fixed:
* Fixed YUYV and UYVY decoding from shmdata sources

Splash 0.10.6 (2024-02-05)
-------------------------
Improvements:
* Updated metainfo and desktop file
* Added (partial) native Wayland support
* Added a fullscreen attribute to Window
* Added informative warnings to configuration and project load methods
* Added a Flatpak test CI job, improved CI overall

Documentation:
* Fixed build instructions

Bugs fixed:
* Fixed staging script regexes
* Fixed Blender addon due to API change in version 4.x
* Fixed issues with sRGB on Windows with OpenGL renderer
* Fixed creating more than one Scene on Windows
* Fixed loading configuration from UI on Windows
* Fixed Window not being resizable from the GUI
* Moved Windows icon to a non-Freedesktop directory

Splash 0.10.4 (2024-01-08)
-------------------------
Improvements:
* Added support for Windows
* Added generation of a Windows installer
* Fixed compilation on Windows
* Rendering of Warp is now active only if control points were modified. Also, added a reset button
* Cleaned up GlWindow and renamed it to RenderingContext
* Added thread sanitation analysis
* Added address sanitation analysis
* Added expiry for temporary CI artifacts
* Added separate graphics implementations for Gui
* Extracted OpenGL implementation from Sink
* Renamed graphics API classes and files to be more consistent
* Harmonized Renderer::create methods, cleaned up Renderer a bit along theh way
* Updated Doctest submodule
* Updated Tracy profiler to v0.10
* Replaced libuuid with stduuid

Bugs fixed:
* Fixed typo in release script
* Fixed ZMQ to use inproc on Windows
* Fix ZMQ channel to better match Pub-Sub pattern
* Fixed VirtualProbe
* Fixed Warp wireframe display
* Fixed compilation with DEBUG_OPENGL flag
* Fixed PboGfxImpl for GLES

Documentation:
* Updated Windows installation information to get around user-specific issues
* Added documentation to build on Windows, reorganized a bit all the systems

Splash 0.10.2 (2023-12-05)
-------------------------
Improvements:
* Renamed attribute "sideness" to "culling" (potentially breaking change, configurations are upgraded automatically)
* Added CI jobs to staging, removed some from develop
* Updated release process, updated scripts and doc to reflect that change
* Added support for initializer lists to Value
* Isolated more OpenGL code into OpenGL and OpenGL ES specific classes
* Shader does not derive from GraphObject anymore
* Removed the need for Framebuffer to have a RootObject
* Removed Image needing a RootObject
* Simplified Renderer API
* Optimized RootObject::updateTreeFromObjects
* Added a sanitization flag to the CMake project

Bugs fixed:
* Brought back 16bits FBO
* Brought back named framebuffers in OpenGL fbo implementation
* Fixed Shader::getShaderInfoLog
* Fixed splash --info, and added a CI test for it
* Fixed GPU framerate not being measured anymore
* Fixed GeometryGfxImpl::buffersTooSmall growing buffers too fast, and added doc
* Fixed issues detected by static analysis

Documentation:
* Fixed documentation here and there

Splash 0.10.0 (2023-11-12)
-------------------------
Improvements:
* Refactored part of the rendering code to allow for support of multiple APIs
* Added support for OpenGL ES 3.2, along OpenGL 4.5
* Removed ffmpeg submodule to always use system lib
* Updated std_image
* Updated CI to limit the number of jobs while keeping diversity
* Dropped CI for Ubuntu 20.04, added CI for 23.10 to prepare next LTS

Bugs fixed:
* Fixed coverage issue
* Fixed profiling with Tracy
* Fixed linting throughout the whole codebase

Documentation:
* Added rendering API documentation to explain partly the new rendering code architecture
* Updated all copyrights to mention Splash authors instead of individual contributors
* Updated make_authors script
* Fixed issue in changelog generated by the release script

Splash 0.9.40 (2023-10-02)
-------------------------
Improvements:
* Updated ZMQ version
* Removed use of Metalab package archive for (soon-to-be-submoduled) shmdata

Bugs fixed:
* Fixed coverage extraction for Gitlab
* Fixed ChannelInput_ZMQ to poll sockets before receiving messages/buffers

Splash 0.9.38 (2023-09-02)
-------------------------
Improvements:
* Code cleanup: unused mutexes, GPU profiling conditions, Syphon sources
* Updated Tracy to version 0.9.1
* Move duplicate shader/program log getting code to a utility function
* Added back inner Scene, renamed as embedded Scene
* Changed FFmpeg submodule to point to their Github mirror, for faster checkout

Bugs fixed:
* Fixed V4L2 YUYV being transformed like sRGB data
* Fixed configuration loading at runtime
* Fixed long connection delay when using shmdata link backend
* Fixed spawned Scene processes not getting a copy of environment variables
* Fixed Shader giving empty error logs, due to geometry shaders without associated sources
* Fixed YUV textures being stored as GL_RGBA, now correctly stored as GL_RG
* Fixed ZMQ input channel eating (twice) 100% of a CPU core while waiting for messages

Documentation:
* Updated documentation
* Added documentation to help with debugging without installing on the system 
* Added documentation for Window::swapBuffers, and tuned the method a bit

Splash 0.9.36 (2023-08-03)
-------------------------
Improvements:
* Added back build test for Debian packaging in package_ubuntu.py
* Updated URLs to match the move to gitlab.com/splashmapper

Splash 0.9.34 (2023-08-02)
-------------------------
Improvements:
* Added -DDEBUG flag by default when compiling in debug
* Updated ZMQ to its latest master commit to date

Bugs fixed:
* Fixed Window read FBO being shared between GL contexts
* Fixed Sink_Shmdata_Encoded compilation with GCC13
* Fixed compile error when building with DEBUG_OPENGL flag
* Fixed UUID constructor which in some cases built an object twice
* Fixed compile error when building with DEBUG_OPENGL flag
* Fixed compilation error with GCC 13 regarding a potentially uninitialized variable in UserInput

Documentation:
* Update README to link to first steps properly
* Added documentation to compile on Fedora

Splash 0.9.32 (2023-03-12)
-------------------------
Improvements:
* Improved slightly the code for Listener
* Fixed Freedesktop categories

Bugs fixed:
* Fixed segfault in listener when looping ring buffer

Splash 0.9.30 (2022-11-11)
-------------------------
Improvements:
* Fixed test coverage
* Fixed gitlab-ci.yml file begin different from the one in debian/master
* Fixed CI to use MPA instead of PPA
* Added source packaging and fixed build on Archlinux
* Separated Debian packages and Blender addon generations
* Added more flexibility to the CMake project to be able to build doc and addons without building Splash
* Activated test coverage evaluation only for develop and master branches

Splash 0.9.28 (2022-10-31)
-------------------------
Bugs fixed:
* Fixed Flatpak package build with Freedesktop SDK 22.08
* Fixed build dependency when OpenCV is not present

Splash 0.9.26 (2022-10-11)
-------------------------
Improvements:
* Updated imgui to 1.88
* Updated snappy to 1.1.9
* Updated stb_image to 2.27 and stb_image_write to 1.16
* Updated GLFW to version 3.3.8
* Updated cppzmq

Bugs fixed:
* Fixed CI not able to get some submodule branches occasionnally, upon updates

Splash 0.9.24 (2022-09-26)
-------------------------
Improvements:
* Reorganized tests assets, separated between unit and integration assets

Bugs fixed:
* Fixed memory overload in Image_NDI, due to buffer being triggered as updated as fast as CPU can

Splash 0.9.22 (2022-09-19)
-------------------------
Improvements:
* Updated package script from using PPA to MPA
* Remove dependency to libzmqpp-dev

Bugs fixed:
* Added some small fixes to the tests
* Filled expectedCRF within size in ColorCalibrator
* Fixed not pulling assets on make test
* Added unit tests for color calibrator
* Added assets before running unit tests
* Added integration test for color calibrator

Documentation:
* Updated contribution to doc, added uninstall instructions for sources
* Removed docs which duplicates what is available on the website
* Removed the build of Splash website from this repo
* Fixed URLs everywhere following the move to sat-mtl Gitlab group

Splash 0.9.20 (2022-06-09)
-------------------------
Improvements:
* Added the ability to relink the GUI to another window
* Added allowing failure for Archlinux job
* Add a way to use image_list for color calibration

Bugs fixed:
* Fixed issue which may arise from filepath being empty in Image_OpenCV
* Fixed NDI image source not handling new video format, switched to UYVY by default

Documentation:
* Removed \brief everywhere

Splash 0.9.18 (2022-05-17)
-------------------------
Improvements:
* Added a way to choose color lut size
* Added a way to change the calibration mode without having to retake captures
* Removed window snapping as it behaved badly

Bugs fixed:
* Fixed color calibration precision loss
* Fixed add command to tree checking that the command branch exists
* Fixed Geometry not checking buffers validity before serializing
* Fixed Python interpreted not respecting the update rate
* Fixed HDR in BGR instead of RGB
* Fixed exposure not correctly updated
* Fixed Sink forcing 8bpc

Documentation:
* Added zip as a dependency for building Splash

Splash 0.9.16 (2022-04-04)
-------------------------
Bugs fixed:
* Fixed queues being locked during buffer sendings in shmdata channels
* Fixed RootObject serializing test
* Fixed Texture_Image RGBA16 and depth not having the correct channel datatype
* Fixed Warp doing its rendering in sRGB instead of RGB16
* Fixed multithreading issue in Log
* Fixed segfault on quit on certain setups
* Fixed a stall when a Python script triggers a Python callback of an attribute

Splash 0.9.14 (2022-03-22)
-------------------------
Bugs fixed:
* Fixed callbacks being called before attributes are set
* Fixed broken decorated parameters of Window from the previous commit
* Fixed Python controller not being able to change window size and decorated attributes

Splash 0.9.12 (2022-02-07)
-------------------------
Bugs fixed:
* Fixed a regression in camera calibration
* Fixed crash in Link when incoming buffer is empty
* Fixed Calimiro-related compilation issues

Splash 0.9.10 (2022-01-10)
-------------------------
Improvements:
* Reduced default texture size to get better out-of-the-box framerate on low-end GPUs
* Added CI for Ubuntu 22.04
* Added Clang to CI
* Updated FFmpeg to version 4.4.2
* Updated Dear ImGui to version 1.86

Bugs fixed:
* Fixed compilation on Ubuntu 22.04

Splash 0.9.8 (2021-12-13)
-------------------------
Bugs fixed:
* Fixed link not being connected with Scene not spawned
* Fixed CI random timeout
* Fixed blending not applied on Scenes other than the main one

Splash 0.9.6 (2021-12-01)
-------------------------
Bugs fixed:
* Fixed issue with clock parameters not being available immediately upon startup
* Fixed link initialization failing sometimes due to an interprocess race condition
* Fixed compilation issue when shmdata is not present

Splash 0.9.4 (2021-10-22)
-------------------------
Improvements:
* Added shmdata for communication between Splash processes
* Updated default 3D model to place the base PoV at a more interesting position

Bugs fixed:
* Fixed ResizableArray double free corruption
* Fixed ImageNDI not having the correct type
* Fixed TexCoordGenerator which could not recompute UVs when the source obj file was not writable

Splash 0.9.2 (2021-10-06)
-------------------------
Bugs fixed:
* Fixed flip/flop parameters
* Fixed random crash in tests around Channel_ZMQ
* Fixed compile issue with perf test when shmdata not available

Documentation:
* Changed the Splash CI so that it uses the new Makefile commands

Splash 0.9.0 (2021-09-20)
-------------------------
Improvements:
* Refactored Link and BufferObject to use Splash::serializer instead of the previous, clunky serialization
* Added alt + right click to simulate middle click
* Added a profiling script to generate flamegraphs
* Moved SerializedObjects away from std::shared_ptr
* Added ZMQ and shmdata performance tests
* Removed inner Scene to allow for more consistant behavior when multiple Scenes are involved
* Improved BufferObject update signal
* Improved buffer sending signaling in Link
* Added shmdata to CI building for Ubuntu
* Changed default World framerate to 15

Bugs fixed:
* Updated ZMQ
* Fixed ZMQ warnings in performance tests
* Fixed ColorCalibrator sending the wrong colorMixMatrix attribute

Documentation:
* Updated the default configuration for better onboarding

Splash 0.8.48 (2021-08-23)
-------------------------
Improvements:
* Fixed use of Image::update throughout the basecode
* Removed a dangling 'using namespace std;' from World

Bugs fixed:
* Fixed Queue not playing Image_v4l2 sources correctly

Splash 0.8.46 (2021-07-08)
-------------------------
Improvements:
* Improved mutex handling in BufferObjects
* Replaced #defines with static const/constexpr

Bugs fixed:
* Fixed integration tests
* Fixed boolean values not being converted correctly in the Python interpreter
* Fixed PyEval_InitThreads being now deprecated and unecessary
* Fixed issue in Texture_Image, with specs being captured before updating the underlying Image

Splash 0.8.44 (2021-05-28)
-------------------------
Improvements:
* Added Image_NDI, a wrapper around ndi2shmdata

Bugs fixed:
* Fixed random segfault in CI when testing Image_Sequence~~capture attribute

Documentation:
* Moved News, License, Contributing and Authors files back to the root

Splash 0.8.42 (2021-05-17)
-------------------------
Improvements:
* Added Gitlab issue templates, updated contributing guide

Bugs fixed:
* Fixed stall in ProfilerGL when no GL object is rendered

Documentation:
* Updated the website with the new version

Splash 0.8.40 (2021-05-03)
-------------------------
Improvements:
* Added Datapath headers, and activated Datapath suppport by default
* Added a reload attribute to Image and Mesh

Bugs fixed:
* Fixed window snapping not updating FBO systematically
* Fixed deadlock when calling texture generation from a script
* Fixed embedded Python interpreter loop exiting when nothing is returned by splash_loop
* Fixed boolean attributes showing as NULL in the Python interpreter

Splash 0.8.38 (2021-04-20)
-------------------------
Improvements:
* Improved BGR to RGB conversion
* Added support for enums in Value
* Added support for Calimiro dome master, equirectangular
* Added camera model to UI for Image_Gphoto
* Improved Medias and Meshes tabulation: if only one is present, it is selected by default

Bugs fixed:
* Fixed building on arm32v7
* Fixed performance issue due to profiling imposing GPU/CPU sync
* Fixed ghost objects which were being rendered as normal objects by the main Scene
* Fixed capture through GPhoto for ColorCalibrator

Documentation:
* Added documentation regarding using a digital camera and color calibration
* Added information regarding running the Flatpak package
* Added list of materials needed for tutorials

Splash 0.8.36 (2021-04-06)
-------------------------
Improvements:
* Added a Calibration panel dedicated to automatic calibration
* Added automatic texture coordinates generation
* Improved GUI information for LTC clock
* Added GPU timings in the GUI
* Added snap to borders to Window
* Added profiling using the Tracy profiler

Bugs fixed:
* Fixed Queue not accepting a video with a start time different from 0 when added first

Documentation:
* Added documentation regarding using NDI with Splash

Splash 0.8.34 (2021-03-22)
-------------------------
Improvements:
* Added lock buttons going red when the attribute is locked

Documentation:
* Added debug compilation documentation

Splash 0.8.32 (2021-03-08)
-------------------------
Bugs fixed:
* Fixed issues following Calimiro api changes
* Fixed issues with non-US keyboards, by updating GLFW

Documentation:
* Fixed broken links

Splash 0.8.30 (2021-02-22)
-------------------------
Improvements:
* Added script to generate Ubuntu package
* Removed some flags specific to colorcalibrator.cpp

Bugs fixed:
* Fixed Cmake not checking for GLFW3 when building against system libs

Documentation:
* Removed docs/index.md

Splash 0.8.28 (2021-02-08)
-------------------------
Improvements:
* Improved nodes behavior in the graph tabulation
* Improved attribute view in the graph tabulation
* Improved Mesh getters
* Renamed mesh getters to .Flat and added addtionnal getters that returns glm::vec

Bugs fixed:
* Fixed FileSelector, added documentation to it, and fixed its usages

Splash 0.8.26 (2021-01-26)
-------------------------
Improvements:
* Pattern flag is now persistent for fixed image sources
* Improved behavior of the GeometricCalibrator upon starting calibration

Bugs fixed:
* Fixed queue objects
* Fixed window position not being updated in the GUI
* Fixed empty leaves being removed when an attribute has an empty value, even though its getter exists
* Fixed issue with not testing that an attribute exists before setting it
* Fixed metainfo file to point to correct image
* Fixed start calibration warning

Documentation:
* Added a tutorial for the automatic calibration
* Added a direct tab for the walkthrough
* Added FAQ entry regarding quads issues
* Reordered walkthrough examples

Splash 0.8.24 (2021-01-11)
-------------------------
Improvements:
* Moved the wiki pages into Splash repo
* Added getter/setter tests for all attributes
* Added the possibility to define an attribute with no setter
* Removed default setter and getter for Attribute
* Improved YUV decoding

Splash 0.8.22 (2020-12-15)
-------------------------
Improvements:
* Improved blending to better support projections with wide depth wrt projector direction
* Reduced visual artefacts sometime generated by blending computation
* Fixed MeshShmdata description
* Removed all 'using namespace std' occurrences
* Added check for Calimiro integration to Splash

Bugs fixed:
* Fixed wireframe/texture button

Splash 0.8.20 (2020-11-30)
-------------------------
Improvements:
* Added localization for keyboard shortcuts
* Added error message popup in the Blender addon
* Updated Blender addon to not force a GPU by default

Bugs fixed:
* Fixed configuration upgrade not handling non-array values correctly

Splash 0.8.18 (2020-11-02)
-------------------------
Improvements:
* Added support for int64 in the GUI
* Improved short description of image_shmdata
* Added configuration file upgrade to 0.8.20

Bugs fixed:
* Fixed crash when not compiled with Portaudio support
* Fixed Camera "hide" parameter which was too complicated for its own good
* Fixed Link handling of boolean Value

Splash 0.8.16 (2020-10-19)
-------------------------
Improvements:
* Added bool as possible Value underlying type
* Added Debian package and Blender addon to website

Bugs fixed:
* Fixed release script not handling multi-digits patch numbers correctly

Splash 0.8.14 (2020-10-05)
-------------------------
Improvements:
* Replaced SFINAE with constexpr in Value definition

Bugs fixed:
* Fixed compilation issue in Sound_Engine

Splash 0.8.12 (2020-09-21)
-------------------------
New features:
* Added the possibility to connect a texture to a warp object

Improvements:
* Added current filename to window titlebar
* Added a GUI entry for master clock input device name
* Added the advanced usages pages to mkdocs
* Added a switch for enabling camera calibration using a joystick
* Changed default path for media folder to ${HOME}
* Replace filesystem access in osUtils to std::filesystem

Bugs fixed:
* Fixed hidden directory being visible
* Fixed issue with directories not ending with a slash
* Fixed audio output device selection
* Fixed attribute type switching from integer to real

Splash 0.8.10 (2020-09-08)
-------------------------
New features:
* Added support to BGRA in the geometric calibrator

Improvements:
* Testing file access in osUtils
* Improved detection of Python3
* Renamed Slaps to Calimiro
* Added Test for geometric calibrator
* Moved custom shader to FilterCustom
* Moved color curves correction to its own filter
* Moved black level into its own filter

Bugs fixed:
* Fixed filter type of geometric_calibrator
* Fixed documentation for Archlinux
* Fixed compilation with GCC 10
* Fixed filter GUI panel not showing derived Filter classes

Splash 0.8.8 (2020-07-06)
-------------------------
Improvements:
* Updated GLFW to version 3.3.2
* Attributes in Python interpreter are now updated inside the main Python loop

Bugs fixed:
* Fixed README for Ubuntu 20.04
* Updated CMake to reflect changes in Slaps
* Fixed Sink grabbing black frames on Nvidia hardware
* Fixed a deadlock generated by last fix
* Fixed Object with no Geometry generating a crash with linked to a Camera

Splash 0.8.6 (2020-06-01)
-------------------------
New features:

- Added a Filter to be created automatically when connecting a Sink to a Texture

Improvements:

- Updated and fixed CI to use Ubuntu 20.04
- Replaced Framebuffer::setParameters with precise setters
- Removed non-necessary method Filter::getOutTexture

Bugs fixed:

- Fixed Warp linking to anything, cleaned up Sink a bit
- Fixed linked time optimization CMake option
- Fixed segfault when creating an empty Geometry object
- Fixed x264 and x264 being not supported by bundled ffmpeg. Added vaapi and amf support to Sink_Shmdata_Encoded
- Fixed Sink not using OpenGL named texture
- Fixed release script which did not update version across the source files

Splash 0.8.4 (2020-05-06)
-------------------------
New features:

- Added a release script, updated contribution guide
- Activated LTO for release builds
- CI now runs Splash to make sure it exits properly
- Added a class that read files from a directory: Image_Sequence
- Updated the Image_Gphoto class to inherit from Image_Sequence
- Added Value::byte_size, and fixed Value::size

Improvements:

- Updated and fixed contribution guide and code of conduct
- Moved argument parsing in splash-app.cpp instead of World
- Cleaned up World buffer serialization and sending
- Removed threaded texture upload, not needed anymore with named textures
- Added the possibility to select which integration test to run
- Improved and documented integration tests
- Added some unit tests, more to come
- Updated the installation documentation to reflect the current procedure
- Updated homepage to point to the new gitlab.io website
- Added configuration for Gitlab.io website
- Added coverage testing for all pipelines
- Added version and compile date auto update for metainfo

Bugs fixed:

- Fixed CONTRIBUTING.md, improved release script a bit
- Fixed issue with file selector when saving to file
- Fixed segfault when launching a child process without a valid DISPLAY
- Fixed spawned processes (as well as cmd line and docs)
- Fixed an assertion when running tests in debug
- Fixed PythonSink
- Fixed an issue in save/load project
- Fixed a false warning which happened when linking after deleting a GraphObject
- Fixed Filter to render by itself, and improved shader uniforms display

Splash 0.8.2 (2019-12-04)
-------------------------
New features:

- Added a default object to the ObjectLibrary, and cleaned it up a bit
- Added an AppData metainfo file

Improvements:

- Cleaned up data subdirectory
- Removed GUI loneliness autodetection, replaced by a flag in it and its parent window
- Removed Shmdata related stuff in the Blender addon, as a separate addon now exists for this
- Removed Flatpak generation from the CI, a [separate repo](https://github.com/flathub/com.gitlab.sat_metalab.Splash) is dedicated to that

Bugs fixed:

- Fixed Flatpak package generation
- Fixed Flatpak package generation, up to a limitation in Freedesktop SDK which does not support stdc++fs yet...
- Fixed Filter not being savable when Object linked directly to Image
- Fixed a freeze when replacing a media after replacing a mesh
- Fixed behavior of textures shown in GUI, leading to less scrollbars

Splash 0.8.0 (2019-11-18)
-------------------------
New features:

- Refactored the GUI!
- Communication between processes is now mainly done through a synchronized tree
- GUI is able to display all the information about all processes
- Completely removed OSX support (at this point, it is a feature)

Improvements:

- Updated Blender addon for version 2.8x
- Updated GLM, ZMQ, LTC, FFmpeg, Hap, GLFW and STB image
- Added possility for Camera, Warp and Filters to output color buffers as an attribute
- Removed distant attributes
- Improved V4L2 support
- Added support for Value::Buffer in the Python interpreter
- Added a 'elapsed' attribute to Queue
- Removed TextureImage::flushPbo which is not necessary anymore
- Fixed banding in input video by converting all inputs to 16bits
- Added live shader update for Filter
- Added support for SLAPS automatic geometric calibration
- Added timestamp propagation from Images and Meshes to Windows
- Added some CLI options

Bugs fixed:

- Fixed texture upload sync blocking render loop too soon
- Fixed hang issue with AMD hardware and RadeonSI driver
- Fixed a bug with blending
- Fixed medias appearing multiple times in the media widget
- Fixed OBJ loader
- Fixed copying calibration from another file
- Fixed issue with NV swap groups
- Fixed offscreen mode

Splash 0.7.20 (2018-09-10)
--------------------------
New features:

- Added Flatpak generation in the CI
- Camera controls are now identical to Blender and Godot: we now use middle mouse button instead of right button
- Added the possibility to disable bundled third party libraries

Improvements:

- Fixed cross-gpu tearing
- Improved cross gpu tearing a bit more, by adding texture upload sync
- Removed a workaround for loading a configuration which is not useful anymore
- Fixed same-dir build (which is evil BTW)
- Added contrast and saturation controls to Camera
- Added an object library, storing 3D objects used in multiple GraphObjects
- Fixed various compilation issue, regarding GCC 8 and OpenCV
- Fixed type inconsistancy between speaker.h and speaker.cpp
- Removed Piccante, replaced it with HDR capabilities from OpenCV
- Textures are now uploaded via persistent PBOs

Bugs fixed:

- Fixed blending computation. Also improved triangles visibility check shader
- Fixed an issue with `Root::disposeObject`
- Fixed compilation issue on Archlinux
- Fixed LTC clock pause signaling
- Added architecture-specific optimization flags unless deactivated through the BUILD_GENERIC_ARCH flag
- Fixed Blender memory sharing with Splash
- Fixed seeking in a video file after it finished playing
- Fixed trimmed video looping endlessly
- Fixed loose clock behavior when LTC paused
- Fixed an issue with device setting in Image_V4L2
- Fixed random issue while setting playlist in Queue
- Fixed V4L2 input not restarting when changing input index, added BGR support
- Fixed crash in Image when reading/writing mediaInfo


Splash 0.7.18 (2018-05-28)
--------------------------
New features:

- Added an alias to objects, which is modifiable by the user and displayed in the GUI

Improvements:

- Object color is used when no texture is linked to it
- Added a \"Reset camera\" button
- Separated PythonEmbedded and PythonSink (SPLASH-424)
- Cleaned up Attributes

Bugs fixed:

- Fixed V4l2 freezing randomly at startup, and projects not updating configuration path
- Fixed issue in replaceObject
- Fixed a leak of glFences (SPLASH-412)
- Fixed issue with Probe node in Blender addon
- Fixed memory leak in image_ffmpeg
- Fixed an issue with name registry and multiple Scenes
- Fixed configuration file upgrade check

Splash 0.7.16 (2018-04-19)
--------------------------
Improvements:

- Upgraded ImGui
- Added a button to resend numeric attributes
- Improved cameras hide behavior
- Added CI for Ubuntu Bionic Beaver
- Improved automatic black value settings
- Refactored the configuration file
- Removed references to OSX from the project (not from the code, yet)
- Cleaned up sources
- Changed GUI font
- Updated --info option output
- Removed the window fullscreen attribute
- Improved calibration through GSL

Bugs fixed
- Fixed issue in Blender addon when exporting mesh_shmdata
- Fixed copy/paste
- Fixed FileSelector and its usage in Gui
- Fixed install target installing Snappy lib and headers
- Fixed compilation on Archlinux
- Fixed a GUI issue: default media when adding to playlist was different that the one displayed
- Fixed crash in ImageFFmpeg when a video file is not found
- Fixed a few issues related to color calibration
- Fixed Texture Image showing in the Media panel
- Fixed master clock, removed Timer dependencies to Value
- Fixed auto black level behavior
- Fixed media panel closing unexpectedly
- Fixed a random segfault in Python callbacks
- Fixed issue when pausing a video
- Fixed project loading when multiple scenes are used
- Fixes in documentation and help

Splash 0.7.14 (2018-02-05)
--------------------------
New features:

- Added the trim attribute to image_ffmpeg                                           
- Added a texture debugging panel                                                    

Improvements:

- Added a Python module search path to Blender addon
- Factory registers objects' savability                                              
- Updated docs                                                                       

Bugs fixed:

- Fixed issues with calibration controls                                             
- Fixed object linked to cameras when loading project                                

Splash 0.7.12 (2018-01-05)
--------------------------
New features:

- Added support for named values, and a mediaInfo attribute to Images

Improvements:

- Added Python as a dependency for CI
- Bundled GL FBOs into the Framebuffer class
- Added get_size() method to Python sink
- Added splash.get_interpreter_name() to Python
- Updated ZMQ and Hap

Bugs fixed:

- Fixed blending when a virtual probe is in use, with multiple GPUs
- Fixed a GPU leak in ProfilerGL
- Fixed issue with command line args

Splash 0.7.10 (2017-12-04)
-------------------------
New features:

- Added -P option to set python script from args                                                                        
- OpenGL performance profiler.                                                                                          
- Ease-of-use for performance profiler flamegraph generation.
- Added conditional profiling of render loop and texture upload

Improvements:

- Updated FFmpeg and Snappy                                  
- Some other Python Sink fixes to make it more reliable                                        
- Removed the splash-scene executable, replaced by an option on splash                                                  
- Added a gui checkbox to activate / deactivate 16bits rendering for all cameras                                        

Bugs fixed:

- Fixes following static analysis                                                                                       
- Hardened Python Sink wrapper                                                                                          
- Bool to int cast caused a crash in python binding. (Hint: don't do it)                                                
- Fixed issues related to GCC 7.2 and Ubuntu 17.10                                                                      

Splash 0.7.8 (2017-10-20)
-------------------------
New features:

- Added method to get master clock from Python
- Added a keepRatio attribute to Filter, and keep_ratio(bool) method to Python sink
- Added python bindings to get an object's type and all objects of a type.

Improvements:

- Every object now has a task queue
- Improved help for Python Sink object
- Replaced SSE2 detection with x86-64 detection
- Specified memory ordering for important atomic operations

Bugs fixed:

- Temporarily fixed banding in dark regions
- Fixed issue with blending happening on calibration markers
- Image_V4L2: fixed a deadlock issue with automatic resizing
- Fixed issue with multiple textures linked to a single image
- Fix: keep relative paths relative

Splash 0.7.6 (2017-09-28)
-------------------------
New features:

- Added a virtual screen object
- Added a loop rate parameter to the Python interpreter
- Hidden the Python splash capsule in the splash module
- Added a Sink wrapper to the Python interpreter
- Added attribute callbacks
- Simulate swap synchro when splash is hidden to avoid taking 100% GPU.

Improvements:

- Added a Probe node to the Blender addon
- Removed ghost-specific commands
- Moved swap interval set from Scene to Window
- Duplicated the link and unlink commands in the World, to simplify the API
- Renamed controller methods
- Added ZMQ as a submodule                
- Added splash.get_timings() to Python API
- Deleted the thread pool, replaced with futures or mere threads.

Bugs fixed:

- Fixed an issue in the Blender exporter, when exporting only the 3D models
- Fixed issue with warps 
- Fixed factory not creating Python controller
- Fixed a #ifdef issue in image_shmdata 
- Fixed Python controller object not loading correctly custom attributes
- Fixed adaptive framerate
- Fixed Python custom attributes
- Fixed integration tests
- Fixed issue with ImGui style editor not building

Splash 0.7.4 (2017-07-31)
-------------------------
New features:

- Added multisampling to camera rendering
- Added anisotropic filtering to Texture_Image

Improvements:

- GUI visible by default when on its own window

Bugs fixed:

- Controller_Gui: fixed clear issue when resizing
- Fixed copy parameters not copying warps


Splash 0.7.2 (2017-07-10)
-------------------------
Improvements:

- Added the reprojection error in the gui
- Updated 2D marker to show the up direction
- Texture upload thread destruction is now at the same place as its creation

Bugs fixed:

- Fixed stopping v4l2 capture
- Fixed live calibration update

Splash 0.7.0 (2017-06-29)
-------------------------
New features:

- Added --prefix option, to add a prefix to shared memories

Improvements:

- Updated ImGui version
- Cleaned up OpenGL context switching
- Added video codecs integration tests
- GL cleanup - removed non useful state changes
- Calibration points targets are now shown by default

Bugs fixed:

- Fixed issue with Sink_Shmdata_Encoded reconnecting ad vitam
- Fixed warp rednering jitter when editing control points
- Fixed a multi-GPU issue
- Fixed GLSL YUV to RGB conversion

Splash 0.6.8 (2017-04-28)
-------------------------
New features:

- Blender: World node can export only 3D models
- Added uninstall target
- Added a splash / about screen

Improvements:

- Can now set any display identifier
- Improved buffer updated signaling

Bugs fixed:

- Fixed issue with Hap and HapAlpha format
- Partially fixed OSX installation instructions
- Fixed a random freeze when exiting while a video is playing
- Fixed throwing error at exit
- Fixed clang compilation error on OSX

Splash 0.6.6 (2017-04-28)
-------------------------
Improvements:

- Converted to OpenGL 4.5
- Improved the file selector
- Sinks now use framerate as a parameter (instead of period), shmdata sinks fill the caps with this parameter
- Moving mouse over a window which does not hold the GUI does not move the mouse on the GUI window anymore

Bugs fixed:

- Fixed warp jittery movement. Still some undesired visual glitches when editing warps
- Fixed window fullscreen behavior

Splash 0.6.4 (2017-04-13)
-------------------------
New features:

- Added a desktop entry

Improvements:

- Some code cleanup, refactored some base classes
- Added object description to the output of splash --info
- Filter: output size can now be overridden

Bugs fixed:

- Fixed installation instructions
- Fixed Debian package

Splash 0.6.2 (2017-03-30)
-------------------------
New features:

* Added automatic black level to filters

Improvements:

* Sinks can now be opened/closed at will
* Can now limit sinks rate, given a period between frames
* GL version and swap group status are now read from getters

Bugs fixed:

* Fixed issues with distant attributes not showing in the controls panel
* Fixed NVSwapGroups

Splash 0.6.0 (2017-03-19)
-------------------------
New features:

* Added a looseClock parameter to control master clock effect on media
* Added a --hide argument for running Splash in background
* Added Sink_Shmdata_Encoded
* Added the possibility to set default values through a configuration file

Improvements:

* Snappy is now included as a submodule
* Image_V4L2: Removed capture rate parameter, which is unused and leads to issues
* Forcing a (working) version number for cppcheck
* Various improvements following static analysis results

Bugs fixed:

* Blender addon: exporting a configuration exists edit mdoe (thus preventing it from crashing)
* Fixed issues with loading image with non-standard size
* Fixed blending issue when loading file with blending activated
* Fixed issue where updating an image with another which has the same resolution needed to be done twice
* Fixed texture format issue
* Fixed issue with --info
* Fixed loose clock behavior when no master clock has been received yet; also, GUI better reflect the loose clock setting

Splash 0.5.8 (2017-03-02)
-------------------------
New features:

* Added support for RGB correction curves in Filter
* Added a static_analysis target, using cppcheck. Also added cppcheck t o gitlab CI
* Added a freerun parameter to media in queue

Improvements:

* Small performance improvements
* Splash now exits with an error if the default 3D models can not be found
* Attributes are now ordered in the GUI
* Refactoring/cleanup of Texture_Image
* Filter: comments places right after uniforms declaration are used as comments in the GUI
* Removed _setMutex, as it was replaced with synced tasks(with addTask)

Bugs fixed:

* Fixed various random issues in Image_FFmpeg
* Fixed issue with PNG saving
* Fixed build on OSX

Splash 0.5.6 (2017-02-10)
-------------------------
New features:

* Refactored ImageBufferSpec to add support for YUV (and other formats). Updated other classes to reflect this change

Improvements:

* Added _tex#_size uniform for Texture_Images
* Blender addon can now export a project (and not the whole configuration)
* Refactored ImageBufferSpec to add support for YUV (and other formats). Updated other classes to reflect this change

Bugs fixed:

* Fixed videos looping before the end
* Fixed issues with planar audio having only the first channel decoded
* Fixed audio sync
* Fixed GUI creating a Python interpreter in every Scene: only the master Scene is worthy
* Fixed a segfault when quitting
* Fixed partly deadlocks occuring when modifying heavily the configuration at runtime

Splash 0.5.4 (2017-01-30)
-------------------------
New features:

* Added a Mesh gui panel
* Added a Sink base class, and Sink_Shmdata
* Added a Sound_Engine class, Speaker can now output to Jack
* Added the possibility to visually show the camera count
* Added a priorityShift attribute to BaseObject

Improvements:

* Timestamps now contain the date
* Added GLFW as a submodule, statically linked
* Filter now accepts files as shaders
* Now using spinlocks where it makes sense
* Improved Filter contrast and brightness settings
* Added recurring tasks to RootObjects; moved swapTest and pingTest to recurring tasks
* Filter now accepts multiple inputs

Bugs fixed:

* Fixed jitter while reading with a queue
* Fixed a crash when creating a texture_image from the gui
* Fixed CI, removed Travis support

Splash 0.5.2 (2017-01-13)
--------------------------
New features:

* Added Video4Linux2 support, as well as Datapath capture cards support
* Added _time (in ms) as a built-in uniform for Filter
* Added --forceDisplay command line option

Splash 0.5.0 (2016-12-09)
--------------------------
New features:

* If possible, Splash now writes logs to /var/log/splash.log
* Added access to logs through Python
* Added get_object_description and get_type_from_category methods to Python module
* Added Debian package build through Docker

Improvements:

* Embedding FFmpeg and link statically to it
* Resetting the up vector when moving the camera manually
* Generates automatically package through Gitlab artifacts
* Objects now have a Class, and can be listed by it by the factory

Bugs fixed:

* Fixed an issue with node view
* Fixed compilation issue on GCC 4.8
* Fixed a bug where configuration parameters had to be arrays, even for single values

Splash 0.4.14 (2016-11-27)
--------------------------
New features:

* Added integration testing using Python
* Objects now ask the configuration path from their root; Added a media path

Improvements:

* BufferObjects now force a World loop iteration, to improve sync
* Fixed an issue in world loop, which was sending empty serialized buffers when the objects were not updated
* Image_FFmpeg: forcing decoding thread_count, works depending on the codec
* Image_FFmpeg: getting video codec info and setting it as an attribute
* Limited threadpool size to 32 instead of 16
* Disable input texture filtering by default, as the Filter class will also create mipmaps

Bugs fixed:

* Fixed an issue with blending computation at startup
* Fixed an issue when trying to replace an object with a non-existing type
* Integration test used installed binary instead of local one
* Fixed an issue with FileSelector, which reverted to run path after the first use
* Image_FFmpeg: fixed read issue with some video codecs

Splash 0.4.12 (2016-11-11)
--------------------------
Improvements:

* Added the possibility to save a project, which holds only media (objects and images), and leaves projectors projectors calibration as is
* Image_FFmpeg: can now set a buffer size limit for the frame queue
* Filter: added an invertChannel attribute, allowing for inverting R and B

Bugs fixed:

* Fixed GPU sync issue
* Fixed an issue when resetting the clock device name to an empty string

Splash 0.4.10 (2016-10-28)
--------------------------
Improvements:

* Separated RT scheduling and core affinity options
* Added a template realtime.conf to be put in /etc/security/limits.d
* Cleaned up the threadpool
* Updated shmdata dependency to version 1.3

Bugs fixed:

* Fix: issue when deleting an image_shmdata object
* Fix: texture upload loop crash when deleting a texture object
* Fix: freeze of the engine (not the gui) when saving configuration while having a camera selected in the calibration view
* Fix: blending crash issue when using multiple GPUs
* Fix: Controller::getObjectTypes returned the local type, instead of the remote type
* Fix: localhost address is now the default option when none is specified.
* Fix: updated default spawn value

Splash 0.4.8 (2016-09-30)
-------------------------
New features:

* Refactored user inputs, now supports drag'n'drop in path fields and copy/paste

Improvements:

* Refactored render loop, to make it more generic...
* ... which led to unexpected performance improvements.
* Cleaned up unit tests.
* Fixed most FFmpeg deprecation warning
* Fixed issues with loading configuration during runtime
* Some code and shader cleanup

Bugs fixed:

* Issues in ResizableArray

Splash 0.4.6 (2016-09-02)
-------------------------
New features:

* Added Doxygen documentation
* Added continuous integration through Travis and Coverity
* Filters now accept user-defined fragment shader
* Objects can use a second texture as a mask

Improvements:

* Added hints for realtime and cpu affinity
* Blending is now handling by a Blender class, not by the Scene
* Removed old blending through a map method

Bugs fixed:

* Fixed blending on Intel / Mesa12.1
* Fixed Blender addon version update on OSX

Splash 0.4.4 (2016-08-05)
-------------------------
New features:

* Scriptable with Python

Improvements:

* Improved vertex blending
* Wireframe coloring when in calibration mode, to help while matching projections
* New GUI font: OpenSans
* Fullsize GUI when alone in a window
* Cleaned Blender nodes
* Cleaned Shmdata objects
* Added a Controller base class, used in particular for Python scripting
* Removed Autotools
* Removed the HttpServer class, as it can now be done through Python
* Added a simple Python script implementing a HTTP server

Bugs fixed:

* Serialization of Geometry
* Random crash in the main loop when sending a serialized object
* Object deletion was not saved

Splash 0.4.2 (2016-06-21)
-------------------------
New features:

* Added automatic documentation generation from in-code attribute description

Improvements:

* Improved and fixed node view
* Cleaned up mutexes
* Can now rename objects from the GUI

Bugs fixed:

* RGB and BGR were inverse in Image_Shmdata
* Fixed window moving after switching decorations

Splash 0.4.0 (2016-06-07)
-------------------------
New features:

* Added CMake as a possible build system. Keeping autotools for now.

Improvements:

* Improved warp GUI
* Improved wireframe rendering
* Improved attributes: added attribute description, can now lock them temporarily
* Messages can now be handling asynchronously in world and scene
* Added GLM as a submodule
* Added limits to calibration
* Queue: auto-complete media duration
* Improve configuration save, now saving world parameters

Bugs fixed:

* Fixed a bug in camera calibration
* Fixed issues with window layout
* Fixed an issue with FFmpeg 3.x
* Fixed an sync issue with vertex blending on multiple GPUs
* Fixed application exit code

Splash 0.3.12 (2016-03-25)
-------------------------
New features:

* Added warp to take care of thoses cases where camera calibration is not sufficient
* Added per-media filter, to control brightness, contrast, saturation and black level
* Added support for threaded HapQ decoding

Improvements:

* Improved performances by reducing the number of buffer copies
* Improved queues
* Improved LTC support
* Added a file selector for media and configurations
* Overall GUI improvements
* Removed dependency to OpenImageIO, now using stb_image
* JsonCpp, libltc and cppzmq are now included as submodules

Bugs fixed:

* Fixed some crashes related to $DISPLAY
* Fixed a crash specific to OSX

Splash 0.3.10 (2015-12-08)
-------------------------
Improvements:

* Improved GUI to hide complexity

Bugs fixed:

* Fixed a random race condition in Timer
* Fixed a crash happening on Object deletion

Splash 0.3.8 (2015-11-22)
-------------------------
Improvements:

* Big improvements to the Blender addon

Splash 0.3.6 (2015-11-13)
-------------------------
New features:

* Added queues, to create playlists of media
* SMTPE LTC can be activated for compatible sources (image_ffmpeg and queues)
* Added a preliminary support for joysticks during calibration

Improvements:

* If possible, no additional process is launched for a Scene
* Improved sound synchronization
* HttpServer can control Scene parameters
* Improved Blender addon
* Improved logs and timing handling

Bugs fixed:

* Fixed a race condition at launch time
* Fixed random freezes when quitting

Splash 0.3.4 (2015-09-30)
-------------------------
New features:

* Sound support in Image_FFmpeg
* Seeking in Image_FFmpeg
* Added architecture for effects on video
* SMPTE LTC support, though not active yet

Improvements:

* Various fixes to enable building on OSX / Homebrew
* Now using GLAD as a GL loader
* Improved HTTP server

Bugs fixed:

* Camera calibration

Splash 0.3.2 (2015-08-05)
-------------------------
New features:

* Real-time blending (for OpenGL >= 4.3)
* Added an HTTP server (not activated by default, draft version)

Improvements:

* More control over the configuration from the GUI
* Slight performance improvements
* Automatic GL version detection
* Improved Blender addon

Bugs fixed:

* Keyboard shortcuts
* Memory leak in Blender addon

Splash 0.3.0 (2015-05-25)
-------------------------
New features:

* Packaged for OSX!
* Added support for Syphon on OSX
* Can read videos through ffmpeg
* Can access video grabbers through OpenCV
* Added an exporter for Blender to ease configuration
* Supports multithreaded Hap

Improvements:

* Improved camera manipulation
* Improved GUI
* Removed dependency to OpenMesh
* Now uses shmdata 1.0
* Various optimizations and fixes

Bugs fixed:

* Fixed shaders to work on ATI cards
* Fixed some crashes

Splash 0.2.2 (2015-02-27)
-------------------------
New features:

* New GUI, more complete and user friendly, based in ImGui (removed GLV)

Improvements:

* Fully OpenGL 3 as GLV has been removed. Less context switching.

Bugs fixed:

* A bug in color calibration prevented it to work in some cases

Splash 0.2.0 (2015-02-18)
-------------------------
New features:

* First version of color and luminance automatic calibration through a camera
* Support for Y422 / UYVY video feed
* Blender addon to feed Splash

Improvements:

* More flexibility for window positioning
* Overall performance improvements
* Better blending map computation
* Calibration points are saved (along calibration itself)

Bugs fixed:

* Now needs 7 points for calibration (6 was not enough in many cases)
* Various bug fixes and code cleanup

Splash 0.1.8 (2014-11-17)
-------------------------
New features:

* NV swap group support
* Mesh update through shared memory (shmdata)
* Flip / flop for input textures
* Color temperature correction

Improvements:

* Slight improvement of blending map computation
* Camera movements now similar to Blender
* Cleaned up header files
* Updated GL debug filters (disabled by default)

Bugs fixed:

* Concurrency issue in Link
* Warnings related to GLM
* Cleanup to compile on Ubuntu 14.04
* Corrected performance issue in Threadpool
* Corrected Threadpool issue with cores number detection
* Channel inversion for RGBA input

Splash 0.1.6 (2014-07-07)
-------------------------
New features:

* HapQ video codec supported

Various bug fixes and improvements

Splash 0.1.4 (2014-05-29)
-------------------------
New improvements:

* Support of 4K @ 30Hz
* GLSL: better uniforms management

Splash 0.1.2 (2014-05-02)
-------------------------
New features:

* Overall performance improvements
* Calibration is now done in realtime
* Removed dependency to OpenCV

Bugs fixed:

* Fixed a random crash happening roughly once a day
* Fixed alignment issues in SSE YUV to RGB conversion
* Fixed a bug when two video sources where configured

New documentation:

* Added a first documentation (README.md)

Splash 0.1.0 (2014-04-06)
-------------------------
First release of Splash

New features:

* Can be used for real
