#define ORANGE vec4(1.f, 0.4f, 0.2f, 1.f)
#define WHITE vec4(1.f)

in VertexData
{
    vec3 bcoord;
} vertexIn;

out vec4 fragColor;

float edgeFactor()
{
    vec3 d = fwidth(vertexIn.bcoord);
    vec3 a3 = smoothstep(vec3(0.f), d * 3.f, vertexIn.bcoord);
    // Here we don't use the x coordinate, so as to not show the
    // diagonals of the bezier patch
    return min(a3.y, a3.z);
}

void main(void)
{
    vec3 b = vertexIn.bcoord;
    float minDist = edgeFactor();
    if (minDist < 1.f) // Not 1.0, so as to get rid of the black edges
        fragColor.rgba = mix(ORANGE, WHITE, edgeFactor());
    else
        discard;
}
