#define PI 3.14159265359

#ifdef TEXTURE_RECT
uniform sampler2DRect _tex0;
#else
uniform sampler2D _tex0;
#endif

in vec2 texCoord;
out vec4 fragColor;

uniform vec2 _tex0_size;
// Texture transformation
uniform int _tex0_flip;
uniform int _tex0_flop;

void main(void)
{
    // Compute the real texture coordinates, according to flip / flop
    vec2 realCoords;
    if (_tex0_flip == 1 && _tex0_flop == 0)
        realCoords = vec2(texCoord.x, 1.f - texCoord.y);
    else if (_tex0_flip == 0 && _tex0_flop == 1)
        realCoords = vec2(1.f - texCoord.x, texCoord.y);
    else if (_tex0_flip == 1 && _tex0_flop == 1)
        realCoords = vec2(1.f - texCoord.x, 1.f - texCoord.y);
    else
        realCoords = texCoord;

#ifdef TEXTURE_RECT
    vec4 color = texture(_tex0, realCoords * _tex0_size);
#else
    vec4 color = texture(_tex0, realCoords);
#endif

    fragColor = color;
}
